<?php

/*include the PEAR XML stuff*/
require_once 'XML/Serializer.php';
require_once 'XML/Unserializer.php';
if((PHP_VERSION>='5')&&extension_loaded('xsl')){
	require_once('xslt-php4-to-php5.php');
	}

/**
 * Aplied to ensure lowercase for all xml tagnames
 *
 */
function caseCorrect($array){
	if(is_array($array)){
		$newarray=array();
		//$array=array_change_key_case($array,CASE_LOWER);
		foreach($array as $key => $value){
			$key=mb_strtolower($key);
			$newarray[$key]=caseCorrect($value);
			}
		}
	else{
		$newarray=$array;
		}
	return $newarray;
	}

/**
 *
 * Takes the root name as input
 *
 */
function xmlpreparer($rootName,$xmlentry,$options=''){
	if($options==''){
		$xmlentry=nullCorrect($xmlentry);
		$xmlentry=caseCorrect($xmlentry);
		$options=array(
					   'addDecl' => FALSE,
					   'encoding' => 'UTF-8',
					   'indent' => '  ',
					   'rootName' => "$rootName",
					   'defaultTagName' => 'undefined',
					   'mode'           => 'simplexml',
					   //	'scalarAsAttributes' => TRUE,
					   //   'attributesArray' => array('field_db', 'label'),
					   //	'contentNAME' => 'value'
					   //	'addDoctype' => true
					   //	'doctype' => array(
					   //	'uri' => 'http://pear.php.net/dtd/package-1.0',
					   //	'id'  => '-//PHP//PEAR/DTD PACKAGE 0.1')
					   );
		}
	$Serializer=&new XML_Serializer($options);
	$status=$Serializer->serialize($xmlentry);
	if(PEAR::isError($status)){die($status->getMessage());}
	return $Serializer->getSerializedData();
	}

/**
 *
 *
 */
function xmlechoer($rootName,$xmlentry){
	$xml=xmlpreparer($rootName,$xmlentry);
	echo $xml;
	}

/**
 * Combines an $xml string with an xsl file which it reads, writes the 
 * html output to a file if (output_filename is set) otherwise just 
 * returns the html
 * Any ouput currently goes to the toplevel directory reports.
 * Still under development!!!!
 */
function xmlprocessor($xml,$xsl_filename,$output_filename=NULL){
	global $CFG;

	$arguments=array(
					 '/_xml' => $xml
					 //,'/_xsl' => $xsl
					 );
	$parameters=array(
					   );
	$xh=xslt_create();
	$filebase='file://'.$CFG->installpath;
	xslt_set_base($xh,$filebase);
	if($output_filename!=''){$output_filename=$filebase.'/reports/'.$output_filename;}
	$html=xslt_process($xh
					   ,'arg:/_xml'
					   ,$filebase.'/templates/'.$xsl_filename 
					   ,$output_filename
					   ,$arguments
					   );
	if(empty($html)){
		trigger_error('XSLT processing error: '. xslt_error($xh), E_USER_WARNING);
		}

	xslt_free($xh);

	return $html;
	}

/**
 * Reads an xml file and xsl file, writes output to a third file
 *
 */
function xmlfileprocessor($xml_filename,$xsl_filename){
	global $CFG;

	$xh=xslt_create();
	$filebase='file://'.$CFG->installpath . '/templates/';
	xslt_set_base($xh,$filebase);
	xslt_process($xh
						 ,$xml_filename 
						 ,$xsl_filename 
						 ,'output2.html'
						 ,$arguments
						 );
	trigger_error('XSLT processing error: '. xslt_error($xh), E_USER_WARNING);
	xslt_free($xh);
	return;
	}


/**
 *
 *
 */
function xmlfilereader($xmlfilename){
	//$xmlentry=nullCorrect($xmlentry);
	$serializer_options=array(
							  'complexType' => 'array'
							  );

	$Unserializer=&new XML_Unserializer($serializer_options);
	$status=$Unserializer->unserialize($xmlfilename,true);
	if(PEAR::isError($status)){
		die($status->getMessage());
		$data=array();
		}
	else{
		$data=$Unserializer->getUnserializedData();
		}
	return $data;
	}

/**
 * Unserialize some $xml to a php array.
 *
 */
function xmlreader($xml){
	$Unserializer=&new XML_Unserializer();
	$status=$Unserializer->unserialize($xml);
	if(PEAR::isError($status)){
		die($status->getMessage());
		$data=array();
		}
	else{
		$data=$Unserializer->getUnserializedData();
		}
	return $data;
	}

/**
 *
 * This overcomes a discrepency in the way XML_Unserializer chooses
 * to generate the array for fields with no value, one value and many
 * values. ClaSS requires they should all be treated as for many
 * values and a numerically indexed array results. Maybe there is an
 * XML_Unserializer option I'm missing that can solve this?
 *
 */
function xmlarray_indexed_check($inarray,$indexname){

	$inarray=(array)$inarray;
	if(is_array($inarray[$indexname])){
		if(!array_key_exists(0,$inarray[$indexname])){
			$inarray[$indexname]=array($inarray[$indexname]);
			}
		}
	elseif($inarray[$indexname]!=''){
		$inarray[$indexname]=array($inarray[$indexname]);
		}
	else{$inarray[$indexname]=array();}

	return $inarray;
	}
?>